#ifndef _MODBUS_MSXE321X_CLIENT_DEFINITION_H_
#define _MODBUS_MSXE321X_CLIENT_DEFINITION_H_

/* this file has been generated by gModbus on Tue Nov 12 14:52:34 2013*/

#include "common_modbus_clientlib.h"



/* Symbolic names for register */
enum {
MSXE321X__TEMPERATUREGETNUMBEROFCHANNELS=19950,
MSXE321X__TEMPERATUREGETCHANNELSENSORCLASS=20000,
MSXE321X__TEMPERATUREDIAGNOSTICS=20200,
MSXE321X__TEMPERATURECALIBRATIONGETCURRENTSTATUS=20400,
MSXE321X__ACQUISITIONGETNUMBEROFCHANNELS=15000,
MSXE321X__ACQUISITIONGETCHANNELSINFO=15050,
MSXE321X__ACQUISITIONAUTOREFRESHGETVALUES=15300,
MSXE321X__ACQUISITIONAUTOREFRESHGETBLOCKINGVALUES=15450,
MSXE321X__ACQUISITIONAUTOREFRESHGETCONFIGURATION=15600,
MSXE321X__ACQUISITIONSEQUENCEGETCONFIGURATION=15650,
};

#ifdef WIN32
#pragma pack(1)
#endif // WIN32

struct MSXE321x__TemperatureGetNumberOfChannels_parameters_t
{
	uint32_t ulNumber;
 } __PACKED;

struct MSXE321x__TemperatureGetChannelSensorClass_parameters_t
{
	uint32_t ulType[16];
 } __PACKED;

struct MSXE321x__TemperatureDiagnostics_parameters_t
{
	uint32_t ulStatus[16];
 } __PACKED;

struct MSXE321x__TemperatureCalibrationGetCurrentStatus_parameters_t
{
	uint32_t ulStatus;
	uint32_t ulChannel;
	float fRefValue;
	uint32_t ulDigitalValue;
 } __PACKED;

struct MSXE321x__AcquisitionGetNumberOfChannels_parameters_t
{
	uint32_t ulNumber;
 } __PACKED;

struct MSXE321x__AcquisitionGetChannelsInfo_parameters_t
{
	uint32_t ulType[16];
	uint32_t ulHwPosition[16];
	uint32_t ulChannelIndex[16];
 } __PACKED;

struct MSXE321x__AcquisitionAutoRefreshGetValues_parameters_t
{
	uint32_t ulTimeStampLow;
	uint32_t ulTimeStampHigh;
	uint32_t ulCounterValue;
	float fValues[16];
 } __PACKED;

struct MSXE321x__AcquisitionAutoRefreshGetBlockingValues_parameters_t
{
	uint32_t ulTimeStampLow;
	uint32_t ulTimeStampHigh;
	uint32_t ulCounterValue;
	float fValues[16];
 } __PACKED;

struct MSXE321x__AcquisitionAutoRefreshGetConfiguration_parameters_t
{
	uint32_t ulChannelMask;
	uint32_t ulAverageValue;
	uint32_t ulRefreshTime;
	uint32_t ulRefreshTimeUnit;
	uint32_t ulTriggerMask;
	uint32_t ulTriggerMode;
	uint32_t ulHardwareTriggerEdge;
	uint32_t ulHardwareTriggerCount;
	uint32_t ulByTriggerNbrOfSeqToAcquire;
	uint32_t ulDataFormat;
	uint32_t ulRunning;
 } __PACKED;

struct MSXE321x__AcquisitionSequenceGetConfiguration_parameters_t
{
	uint32_t ulNbrOfChannel;
	uint32_t ulChannelList[16];
	uint32_t ulAcquisitionTime;
	uint32_t ulAcquisitionTimeUnit;
	uint32_t ulNbrOfSequence;
	uint32_t ulNbrMaxSequenceToTransfer;
	uint32_t ulTriggerMask;
	uint32_t ulTriggerMode;
	uint32_t ulHardwareTriggerEdge;
	uint32_t ulHardwareTriggerCount;
	uint32_t ulByTriggerNbrOfSeqToAcquire;
	uint32_t ulDataFormat;
	uint32_t ulRunning;
 } __PACKED;

#ifdef WIN32
#pragma pack()
#endif // WIN32



/** <p>Return the number of temperature channels.</p>
* <p>
* <b>Parameters:</b>
* </p>
* <ul>
* <p>@param[out] <b> <VAR>ulNumber </VAR> </b> Return the number of available temperature channels</p>
* </ul>
* <p><b> Returns:</b></p>
* <ul>
* @return <b>Possible return value on the remote system (read them with GetLastCommandStatus)</b>
* </ul>
*/
			


/* @return 0 on success, -1 on system error, -2 on modbus exception, -3 if the received answer is incorrect */
int modbus_call_MSXE321x__TemperatureGetNumberOfChannels(struct modbus * modbus,struct MSXE321x__TemperatureGetNumberOfChannels_parameters_t * Response);



/** <p>Return the type of the temperature channels.</p>
* <p>
* <b>Parameters:</b>
* </p>
* <ul>
* <p>@param[out] <b> <VAR>ulType </VAR> </b> Array that contain the channels class (0 : RTD, 1 : TC, 2 : NTC)
* <ul>
*                                            <li> ulType [0] : Channel 0 type
*                                            <li> ...
*                                            <li> ulType [15] : Channel 15 type
* </ul>
* </p>
* </ul>
* <p><b> Returns:</b></p>
* <ul>
* @return <b>Possible return value on the remote system (read them with GetLastCommandStatus)</b>
* </ul>
*/
			


/* @return 0 on success, -1 on system error, -2 on modbus exception, -3 if the received answer is incorrect */
int modbus_call_MSXE321x__TemperatureGetChannelSensorClass(struct modbus * modbus,struct MSXE321x__TemperatureGetChannelSensorClass_parameters_t * Response);



/** <p>Temperature lines diagnostic</p>
* <p>
* <b>Parameters:</b>
* </p>
* <ul>
* <p>@param[out] <b> <VAR>ulType </VAR> </b> Array that contain the channels class (0 : RTD, 1 : TC, 2 : NTC)
* <ul>
*                                            <li> ulStatus [0] : Channel 0 status<ul>
*                                                                <li> 0 : OK </li>
*                                                                <li> 1 : RTD voltage line open </li>
*                                                                <li> 2 : RTD voltage line short circuit </li>
*                                                                <li> 3 : RTD current line open </li>
*                                                                <li> 4 : RTD current line short circuit </li>
*                                                                <li> 5 : TC disconnected </li>
*                                                                <li> 6 : CJC disconnected (M12 connector not present) </li>
*                                                                <li> 7 : RTD sensor front-end disconnected (wiring properly linked) </li></lu>
*                                            <li> ...
*                                            <li> ulStatus [15] : Channel 15 ulStatus
* </ul>
* </p>
* </ul>
* <p><b> Returns:</b></p>
* <ul>
* @return <b>Possible return value on the remote system (read them with GetLastCommandStatus)</b>
* </ul>
*/
			


/* @return 0 on success, -1 on system error, -2 on modbus exception, -3 if the received answer is incorrect */
int modbus_call_MSXE321x__TemperatureDiagnostics(struct modbus * modbus,struct MSXE321x__TemperatureDiagnostics_parameters_t * Response);



/** <p>Return the type of the analog input channels</p>
*<p><b>Parameters:</b></p>
* <ul>
* <p> @param[out] <b> <VAR>ulStatus </VAR> </b> Calibration current status
* <ul>
*                  <li> 0: No calibration in progress
*                  <li> 1: Wait to setting the reference value
*                  <li> 2: Selected reference value calibration in progress
*                  <li> 3: Calibration finiched
*                  <li> 4: User break occur
*                  <li> 5: Can not calibrate the selected reference value
* </ul>
* </p>
* <p> @param[out] <b> <VAR>ulChannel : </VAR> </b> Current calibration channel </p>
* <p> @param[out] <b> <VAR>fRefValue : </VAR> </b> Current selected calibration reference value </p>
* <p> @param[out] <b> <VAR>ulDigitalValue : </VAR> </b> Last measured digital value </p>
* </p>
* </ul>
* <p><b> Returns:</b></p>
* <ul>
* @return <b>Possible return value on the remote system (read them with GetLastCommandStatus)</b>
* <ul>
* <li><b> <VAR>syserrno :</VAR> </b> system-error code (the value of the libc "errno" code) EPERM means a autorefresh acquisition was not started.
* </ul></ul>
*/
			


/* @return 0 on success, -1 on system error, -2 on modbus exception, -3 if the received answer is incorrect */
int modbus_call_MSXE321x__TemperatureCalibrationGetCurrentStatus(struct modbus * modbus,struct MSXE321x__TemperatureCalibrationGetCurrentStatus_parameters_t * Response);



/** <p>Return the number of acquisition channels.</p>
* <p><b>Parameters</b></p>
* <ul>
* 	<li>@param[out] <b> <VAR>ulNumber </VAR> </b> Return the number of available acquisition channels</li>
* </ul>
* <p><b>Returns</b></p>
* <p>Possible return value on the remote system (read them with GetLastCommandStatus).</p>
* <ul>
*	<li><b>0</b> The remote function performed OK</li>
*	<li><b>-100</b> Internal system error occurred. See value of syserrno</li>
* </ul>
*/
			


/* @return 0 on success, -1 on system error, -2 on modbus exception, -3 if the received answer is incorrect */
int modbus_call_MSXE321x__AcquisitionGetNumberOfChannels(struct modbus * modbus,struct MSXE321x__AcquisitionGetNumberOfChannels_parameters_t * Response);



/** <p>Return the acquisition channels type and hardware position.</p>
* <p><b>Parameters:</b></p>
* <ul>
* 	<li>@param[out] <b> <VAR>ulType </VAR> </b> Array that contains the channels type.
* 		<ul>
*			<li> 0 : Not available </li>
*			<li> 1 : Temperature channel </li>
*			<li> 2 : Pressure channel </li>
*			<li> 3 : Transducer channel </li>
*			<li> 4 : Analog input channel </li>
*			<li> 5 : Analog input ICP channel </li>
*			<li> 6 : Digital I/O port </li>
*		</ul>
*		<ul>
*			<li> ulType [0] : Channel 0 type</li>
*			<li> ...</li>
*			<li> ulType [15] : Channel 15 type</li>
*		</ul>
*	</li>
*	<li>@param[out] <b> <VAR>ulHwPosition </VAR> </b> Array that contain the hardware position index (0 to 7)
* 		<ul>
*			<li> ulType [0] : Channel 0 hardware position index</li>
*			<li> ...</li>
*			<li> ulType [15] : Channel 15 hardware position index</li>
*		</ul>
* 	</li>
*	<li>@param[out] <b> <VAR>ulChannelIndex </VAR> </b> Array that contain the functionality channel index.
* 		<ul>
*			<li> ulType [0] : Channel 0 hardware position index</li>
*			<li> ...</li>
*			<li> ulType [15] : Channel 15 functionality channel index</li>
*		</ul>
*	</li>
* </ul>
* <p><b>Returns</b></p>
* <p>Possible return value on the remote system (read them with GetLastCommandStatus).</p>
* <ul>
*	<li><b>0</b> The remote function performed OK</li>
*	<li><b>-2</b> Channel selection wrong</li>
*	<li><b>-100</b> Internal system error occurred. See value of syserrno</li>
* </ul>
*/
			


/* @return 0 on success, -1 on system error, -2 on modbus exception, -3 if the received answer is incorrect */
int modbus_call_MSXE321x__AcquisitionGetChannelsInfo(struct modbus * modbus,struct MSXE321x__AcquisitionGetChannelsInfo_parameters_t * Response);



/** <p> Returns the values acquired in auto refresh mode</p>
* <p><b>Parameters:</b></p>
* <ul>
* 	<li>@param[out] <b> <VAR>ulTimeStampLow</VAR> </b> Number of microseconds since epoch</li>
* 	<li>@param[out] <b> <VAR>ulTimeStampHigh </VAR> </b> Number of seconds since epoch</li>
* 	<li>@param[out] <b> <VAR>ulAutoRefreshCounter </VAR> </b> Number of sequence acquisition since the start</li>
* 	<li>@param[out] <b> <VAR>fValues </VAR> </b> Array that contains the channels values
*		<ul>
*			<li> pdValues [0] : Channel 0 value</li>
*			<li>  ...</li>
*			<li> pdValues [15] : Channel 15 value</li>
* 		</ul>
*	</li>
* <p><b> Returns:</b></p>
* <p>Possible return value on the remote system (read them with GetLastCommandStatus).</p>
* <ul>
*	<li><b>0</b> The remote function performed OK</li>
*	<li><b>-2</b> No Acquisition in progress</li>
*	<li><b>-3</b> 2s timeout occur (If you have enabled the blocking mode).</li>
*	<li><b>-100</b> Internal system error occurred. See value of syserrno</li>
* </ul>
*/
			


/* @return 0 on success, -1 on system error, -2 on modbus exception, -3 if the received answer is incorrect */
int modbus_call_MSXE321x__AcquisitionAutoRefreshGetValues(struct modbus * modbus,struct MSXE321x__AcquisitionAutoRefreshGetValues_parameters_t * Response);



/** <p> Returns the values acquired in auto refresh mode after a new cycle occur (wait a new auto refresh value cycle)</p>
* <p><b>Parameters:</b></p>
* <ul>
* 	<li>@param[out] <b> <VAR>ulTimeStampLow</VAR> </b> Number of microseconds since epoch</li>
* 	<li>@param[out] <b> <VAR>ulTimeStampHigh </VAR> </b> Number of seconds since epoch</li>
* 	<li>@param[out] <b> <VAR>ulAutoRefreshCounter </VAR> </b> Number of sequence acquisition since the start</li>
* 	<li>@param[out] <b> <VAR>fValues </VAR> </b> Array that contains the channels values
*		<ul>
*			<li> pdValues [0] : Channel 0 value</li>
*			<li>  ...</li>
*			<li> pdValues [15] : Channel 15 value</li>
* 		</ul>
*	</li>
* <p><b> Returns:</b></p>
* <p>Possible return value on the remote system (read them with GetLastCommandStatus).</p>
* <ul>
*	<li><b>0</b> The remote function performed OK</li>
*	<li><b>-2</b> No Acquisition in progress</li>
*	<li><b>-3</b> 2s timeout occur (If you have enabled the blocking mode).</li>
*	<li><b>-100</b> Internal system error occurred. See value of syserrno</li>
* </ul>
*/
			


/* @return 0 on success, -1 on system error, -2 on modbus exception, -3 if the received answer is incorrect */
int modbus_call_MSXE321x__AcquisitionAutoRefreshGetBlockingValues(struct modbus * modbus,struct MSXE321x__AcquisitionAutoRefreshGetBlockingValues_parameters_t * Response);



/** <p> Get the current auto refresh acquisition configuration. </p>
* <p><b>Parameters:</b></p>
* <ul>
* 	<li>@param[out] <b><VAR> ulChannelMask </VAR></b> Mask of the channel acquired by the auto refresh (1 bit = 1 Channel). If the value returned is 0, then the auto refresh acquisition is not initialised. </li>
* 	<li>@param[out] <b><VAR> ulAverageValue </VAR></b> Average value
*		<ul>
*			<li> 1 : not used </li>
*			<li> max value : 255 </li>
*		</ul>
*	</li>
*	<li>@param[out] <b><VAR> ulRefreshTimeUnit </VAR></b> Refresh Time Unit
*		<ul>
*			<li> 0 : microsecond</li>
*			<li> 1 : millisecond</li>
*			<li> 2 : second </li>
*		</ul>
*	</li>
*	<li>@param[out] <b><VAR> ulRefreshTime </VAR></b> Refresh Time
*		<ul>
*			<li> range from min 1000 to 65535 when the unit is the microsecond</li>
*			<li> range from min 1 to 65535 when the unit is the millisecond</li>
*			<li> range from min 1 to 65535 when the unit is the second </li>
*		</ul>
*	</li>
* 	<li>@param[out] <b><VAR> ulTriggerMask </VAR></b> Define the source of the trigger
*		<ul>
*			<li> 0 : trigger disabled</li>
*			<li> 1 : Enable Hardware Digital Input Trigger</li>
*			<li> 2 : Enable Synchro Trigger</li>
*			<li> 4 : Enable Compare Trigger (only useful if your system has incremental counter or Sine/Cosine input)</li>
*			<li> 8 : Enable Index Trigger (only useful if your system has Sine/Cosine input)</li>
*		</ul>
*	</li>
* 	<li>@param[out] <b><VAR> ulTriggerMode </VAR></b> Define the trigger mode
*		<ul>
*			<li> 1 : One shot trigger</li>
*			<li> 2 : Sequence trigger </li>
*		</ul>
*	</li>
* 	<li>@param[out] <b><VAR> ulHardwareTriggerEdge </VAR></b> Define the edge of the hardware trigger who generates a trigger action
*		<ul>
*			<li> 1 : rising edge (Only if hardware trigger selected)</li>
*			<li> 2 : falling edge (Only if hardware trigger selected)</li>
*			<li> 3 : Both front (Only if hardware trigger selected) </li>
*		</ul>
*	</li>
*	<li>@param[out] <b><VAR> ulHardwareTriggerCount </VAR></b> Define the number of trigger events before the action occur
*		<ul>
*			<li> 1 : all trigger event start the action</li>
*			<li> max value : 65535 </li>
*		</ul>
*	</li>
* 	<li>@param[out] <b><VAR> ulByTriggerNbrOfSeqToAcquire </VAR></b> Define the number of sequence to acquire by each trigger event
*		<ul>
*			<li> 0 : continuous mode</li>
*			<li> 0 : number of sequence : (1..0xFFFFFFFF) </li>
*		</ul>
*	</li>
* 	<li>@param[out] <b><VAR> ulDataFormat </VAR></b>
*		<ul>
*			<li> D0 : Absolute time stamp information
*				<ul>
*					<li> 0: no time stamp information</li>
*					<li> 1: time stamp information </li>
*				</ul>
*			</li>
*			<li> D1 : Relative time stamp information
*				<ul>
*					<li> 0: no time stamp information</li>
*					<li> 1: time stamp information </li>
*				</ul>
*			</li>
*			<li> D2 : Auto refresh counter information
*				<ul>
*					<li>  0 : No auto refresh counter information</li>
*					<li>  1 : Auto refresh counter information </li>
*				</ul>
*			</li>
*			<li> D3 : System status information
*				<ul>
*					<li>  0 : No system status information required</li>
*					<li>  1 : System status information required</li>
*				</ul>
*			</li>
*			<li> D4 : Data format
*				<ul>
*					<li> 0: Digital value</li>
*					<li> 1: Analog value </li>
*				</ul>
*			</li>
*		</ul>
*	</li>
* 	<li>@param[out] <b><VAR> ulRunning </VAR></b> Auto refresh acquisition running state
*		<ul>
*			<li> 0 : Not running</li>
*			<li> 1 : Auto refresh acquisition running </li>
*		</ul>
*	</li>
* </ul>
* <p><b> Returns:</b></p>
* <p>Possible return value on the remote system (read them with GetLastCommandStatus).</p>
* <ul>
*	<li><b>0</b> The remote function performed OK</li>
*	<li><b>-100</b> Internal system error occurred. See value of syserrno</li>
* </ul>
*/
			


/* @return 0 on success, -1 on system error, -2 on modbus exception, -3 if the received answer is incorrect */
int modbus_call_MSXE321x__AcquisitionAutoRefreshGetConfiguration(struct modbus * modbus,struct MSXE321x__AcquisitionAutoRefreshGetConfiguration_parameters_t * Response);



/** <p> Get the current sequence acquisition configuration.</p>
* <p><b>Parameters</b></p>
* <ul>
* 	<li>@param[out] <b><VAR> ulNbrOfChannel </VAR></b> Nbr of channel in the sequence. If 0 no sequence initialised</li>
* 	<li>@param[out] <b><VAR> psChannelList </VAR></b> List of the channel who compose the sequence.</li>
* 	<li>@param[out] <b><VAR> ulAcquisitionTime </VAR></b> Acquisition Time
*		<ul>
*			<li> range from min 1000 to 65535 when the unit is the microsecond</li>
*			<li> range from min 1 to 65535 when the unit is the millisecond</li>
*			<li> range from min 1 to 65535 when the unit is the second</li>
*		</ul>
*	</li>
* 	<li>@param[out] <b><VAR> ulAcquisitionTimeUnit </VAR></b> Acquisition Time Unit
*		<ul>
*			<li> 0 : us</li>
*			<li> 1 : ms</li>
*			<li> 2 : s </li>
*		</ul>
*	</li>
* 	<li>@param[out] <b><VAR> ulNbrOfSequence </VAR></b> Number of sequence to acquire
*		<ul>
*			<li> 0 : continuous mode</li>
*			<li> Superior to 0 : number of sequence </li>
*		</ul>
*	</li>
* 	<li>@param[out] <b><VAR> ulNbrMaxSequenceToTransfer </VAR></b> Max number of sequence to acquire before a data transfer. (from 1 to 65535)</li>
* 	<li>@param[out] <b><VAR> ulTriggerMask </VAR></b> Define the source of the trigger
*		<ul>
*			<li> 0 : trigger disabled</li>
*			<li> 1 : Enable Hardware Digital Input Trigger</li>
*			<li> 2 : Enable Synchro Trigger</li>
*			<li> 4 : Enable Compare Trigger (only useful if your system has incremental counter or Sine/Cosine input) </li>
*			<li> 8 : Enable Index Trigger (only useful if your system has Sine/Cosine input)</li>
*		</ul>
*	</li>
*	<li>@param[out] <b><VAR> ulTriggerMode </VAR></b> Define the trigger mode
*		<ul>
*			<li> 1 : One shot trigger</li>
*			<li> 2 : Sequence trigger </li>
*		</ul>
*	</li>
* 	<li>@param[out] <b><VAR> ulHardwareTriggerEdge </VAR></b> Define the edge of the hardware trigger who generate a trigger action
*		<ul>
*			<li> 1 : rising front (Only if hardware trigger selected)</li>
*			<li> 2 : falling front (Only if hardware trigger selected)</li>
*			<li> 3 : Both front (Only if hardware trigger selected) </li>
*		</ul>
*	</li>
* 	<li>@param[out] <b><VAR> ulHardwareTriggerCount </VAR></b> Define the number of trigger events before the action occur
*		<ul>
*			<li> 1 : all trigger event start the action</li>
*			<li> max value : 65535 </li>
*		</ul>
*	</li>
* 	<li>@param[out] <b><VAR> ulByTriggerNbrOfSeqToAcquire </VAR></b> define the number of sequence to acquire by each trigger event
*		<ul>
*			<li> 0 : continuous mode</li>
*			<li> Superior to 0 : number of sequence : (1..0xFFFFFFFF) </li>
*		</ul>
*	</li>
* 	<li>@param[out] <b><VAR> ulDataFormat </VAR></b> Data format option
*		<ul>
*			<li> D0 : Absolute time stamp information
*				<ul>
*					<li> 0: no time stamp information</li>
*					<li> 1: time stamp information </li>
*				</ul>
*			</li>
*			<li> D1 : Relative time stamp information
*				<ul>
*					<li> 0: no time stamp information</li>
*					<li> 1: time stamp information </li>
*				</ul>
*			</li>
*			<li> D2 : Sequence counter information
*				<ul>
*					<li> 0 : No sequence counter information</li>
*					<li> 1 : Sequence counter information</li>
*				</ul>
*			</li>
*			<li> D3 : System status information
*				<ul>
*					<li>  0 : No system status information required</li>
*					<li>  1 : System status information required</li>
*				</ul>
*			</li>
*			<li> D4 : Data format
*				<ul>
*					<li> 0: Digital value</li>
*					<li> 1: Analog value </li>
*				</ul>
*			</li>
*		</ul>
*	</li>
* 	<li>@param[out] <b><VAR> ulRunning </VAR></b> Sequence acquisition running state
*		<ul>
*			<li> 0 : Not running</li>
*			<li> 1 : Sequence acquisition running </li>
*		</ul>
* 	</li>
* </ul>
* <p><b> Returns:</b></p>
* <p>Possible return value on the remote system (read them with GetLastCommandStatus).</p>
* <ul>
*	<li><b>0</b> The remote function performed OK</li>
*	<li><b>-100</b> Internal system error occurred. See value of syserrno</li>
* </ul>
*/
			


/* @return 0 on success, -1 on system error, -2 on modbus exception, -3 if the received answer is incorrect */
int modbus_call_MSXE321x__AcquisitionSequenceGetConfiguration(struct modbus * modbus,struct MSXE321x__AcquisitionSequenceGetConfiguration_parameters_t * Response);


/* Symbolic names for register */
enum {
MSXE321X__SETDATACURSOR=65530,
MSXE321X__TEMPERATURESETCHANNELTYPE=20450,
MSXE321X__TEMPERATURESETSAMPLINGRATE=20500,
MSXE321X__TEMPERATURECALIBRATIONSTART=20550,
MSXE321X__TEMPERATURECALIBRATIONNEXTSTEP=20600,
MSXE321X__TEMPERATURECALIBRATIONBREAK=20650,
MSXE321X__ACQUISITIONAUTOREFRESHINITANDSTART=15750,
MSXE321X__ACQUISITIONAUTOREFRESHSTOPANDRELEASE=15850,
MSXE321X__ACQUISITIONSEQUENCEINITANDSTART=15900,
MSXE321X__ACQUISITIONSEQUENCESTOPANDRELEASE=15950,
};

#ifdef WIN32
#pragma pack(1)
#endif // WIN32

struct MSXE321x__SetDataCursor_parameters_t
{
	uint32_t ulCursor;
 } __PACKED;

struct MSXE321x__TemperatureSetChannelType_parameters_t
{
	uint32_t ulChannel;
	uint32_t ulType;
	uint32_t ulOption1;
 } __PACKED;

struct MSXE321x__TemperatureSetSamplingRate_parameters_t
{
	uint32_t ulChannelGroup;
	uint32_t ulBaseSamplingRate;
	uint32_t ulOption1;
 } __PACKED;

struct MSXE321x__TemperatureCalibrationStart_parameters_t
{
	uint32_t ulChannelGroup;
	uint32_t ulGainSelection;
	uint32_t ulNbrOfRefValues;
	float fRefValues[16];
 } __PACKED;

struct MSXE321x__TemperatureCalibrationNextStep_parameters_t
{
	uint32_t ulOption01;
 } __PACKED;

struct MSXE321x__TemperatureCalibrationBreak_parameters_t
{
	uint32_t ulOption01;
 } __PACKED;

struct MSXE321x__AcquisitionAutoRefreshInitAndStart_parameters_t
{
	uint32_t ulChannelMask;
	uint32_t ulAverageValue;
	uint32_t ulRefreshTime;
	uint32_t ulRefreshTimeUnit;
	uint32_t ulTriggerMask;
	uint32_t ulTriggerMode;
	uint32_t ulHardwareTriggerEdge;
	uint32_t ulHardwareTriggerCount;
	uint32_t ulByTriggerNbrOfSeqToAcquire;
	uint32_t ulDataFormat;
	uint32_t ulForceStart;
	uint32_t ulOption1;
	uint32_t ulOption2;
	uint32_t ulOption3;
 } __PACKED;

struct MSXE321x__AcquisitionAutoRefreshStopAndRelease_parameters_t
{
	uint32_t ulOption1;
 } __PACKED;

struct MSXE321x__AcquisitionSequenceInitAndStart_parameters_t
{
	uint32_t ulNbrOfChannel;
	uint32_t ulChannelList[16];
	uint32_t ulAcquisitionTime;
	uint32_t ulAcquisitionTimeUnit;
	uint32_t ulNbrOfSequence;
	uint32_t ulNbrMaxSequenceToTransfer;
	uint32_t ulTriggerMask;
	uint32_t ulTriggerMode;
	uint32_t ulHardwareTriggerEdge;
	uint32_t ulHardwareTriggerCount;
	uint32_t ulByTriggerNbrOfSeqToAcquire;
	uint32_t ulDataFormat;
	uint32_t ulForceStart;
	uint32_t ulOption1;
	uint32_t ulOption2;
	uint32_t ulOption3;
 } __PACKED;

struct MSXE321x__AcquisitionSequenceStopAndRelease_parameters_t
{
	uint32_t ulOption01;
 } __PACKED;

#ifdef WIN32
#pragma pack()
#endif // WIN32


/** <p>Change the active data cursor cursor</p>
*
* <p><b>Parameters:</b></p><ul>
* <p>@param[in] <b><VAR>ulCursor:</VAR></b> New cursor value </p>
* </ul>
*
* <p><b> Returns:</b></p><ul>
*
* @return <b>Possible return value on the remote system (read them with GetLastCommandStatus)</b>
* <ul>
* <li> 0: success \n
* <li> -1:  otherwise : internal error \n
* </ul>
*/
	
/*
@return 0 on success, -1 on system error, -2 on MODBUS exception (the exception code is in modbus->exception), -3 if response from remote system is incorrect, -4 if the remote call generated a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed
*/

/* Below is an example on how this function is intended to be used

int sample_MSXE321x__SetDataCursor(struct modbus * modbus)
{

	//variables declaration

	struct GetLastCommandStatus_parameters_t CommandStatus;
	int ret = 0;
	uint32_t ulCursor;

	//Initialise variables here

	//Remote function call
	ret = modbus_call_MSXE321x__SetDataCursor(modbus,ulCursor,&CommandStatus);

	//Return value check
	switch(ret)
	{
		case 0: // OK
			break;
		case -1: // system error
			perror("MSXE321x__SetDataCursor");
			return -1;
			break;
		case -2: // MODBUS exception
			switch(modbus->exception)
			{
				case MODBUS_REMOTE_EXECUTION_ERROR: // actually a remote exception error and we get it in CommandStatus
					printf("Remote command returned: %d\n",MODBUS_NTOHL((int) (CommandStatus.ReturnValue)) );
					*(CommandStatus.Errstr+sizeof(CommandStatus.Errstr)-1)='\0';
					printf("Remote errno: %d (%s)\n",(int)MODBUS_NTOHL((int)CommandStatus.Syserrno),CommandStatus.Errstr);
					return -1;
					break;
				default:
					printf("remote system returned a MODBUS exception for command MSXE321x__SetDataCursor\n");
					printf("reason: %s (%d)\n",modbus_exception_to_str(modbus->exception),modbus->exception);
					return -1;
					break;
			}
			break;
		case -3: // incorrect response from remote system
			printf("incorrect response from remote system\n");
			return -1;
			break;
		case -4: 
			printf("remote system returned a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed\n");
			return -1;
			break;
		default: 
			printf("unknown return code %d from MSXE321x__SetDataCursor()\n",ret);
			return -1;
			break;
	}
	printf("call to MSXE321x__SetDataCursor OK\n");
	return 0;
}

*/

int modbus_call_MSXE321x__SetDataCursor(struct modbus * modbus,
	uint32_t ulCursor
, struct GetLastCommandStatus_parameters_t * CommandStatus);

/** <p>Temperature sensor type selection for the selected channel</p>
*<p><b>Parameters:</b></p>
* <ul>
* <p>@param[in] <b><VAR> ulChannel </VAR></b> Channel selection. 0 to 15</p>
* <p>@param[in] <b><VAR> ulType </VAR></b> Type selection.<ul>
*                          <li> For TC <ul>
*                               <li> 1: Type B
*                               <li> 5: Type E
*                               <li> 10: Type J
*                               <li> 11: Type K
*                               <li> 14: Type N
*                               <li> 18: Type R
*                               <li> 19: Type S
*                               <li> 20: Type T </ul>
*                          <li> For RTD type PT  <ul>
*                               <li> 100: PT100
*                               <li> 200: PT200
*                               <li> 500: PT500
*                               <li> 1000: PT1000
*                               <li> ...</ul>
*                          <li> For RTD type Ni  <ul>
*                               <li> 101: Ni100
*                               <li> 201: Ni200
*                               <li> 501: Ni500
*                               <li> 1001: Ni1000
*                               <li> ...</ul>
*                          <li> For NTC <ul>
*                               <li> 1: G10K4D453
*                               <li> ...</ul></ul></p>
* <p>@param[in] <b><VAR> ulOption1 </VAR></b> Reserved. Set to 0</p>
*
* </ul>
* <p><b> Returns:</b></p>
* <ul>
* @return <b>Possible return value on the remote system (read them with GetLastCommandStatus)</b>
* <ul>
* <li><b> <VAR>syserrno :</VAR> </b> system-error code (the value of the libc "errno" code) EPERM means a autorefresh acquisition was not started.
* </ul></ul>
*/
		
/*
@return 0 on success, -1 on system error, -2 on MODBUS exception (the exception code is in modbus->exception), -3 if response from remote system is incorrect, -4 if the remote call generated a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed
*/

/* Below is an example on how this function is intended to be used

int sample_MSXE321x__TemperatureSetChannelType(struct modbus * modbus)
{

	//variables declaration

	struct GetLastCommandStatus_parameters_t CommandStatus;
	int ret = 0;
	uint32_t ulChannel;
	uint32_t ulType;
	uint32_t ulOption1;

	//Initialise variables here

	//Remote function call
	ret = modbus_call_MSXE321x__TemperatureSetChannelType(modbus,ulChannel,ulType,ulOption1,&CommandStatus);

	//Return value check
	switch(ret)
	{
		case 0: // OK
			break;
		case -1: // system error
			perror("MSXE321x__TemperatureSetChannelType");
			return -1;
			break;
		case -2: // MODBUS exception
			switch(modbus->exception)
			{
				case MODBUS_REMOTE_EXECUTION_ERROR: // actually a remote exception error and we get it in CommandStatus
					printf("Remote command returned: %d\n",MODBUS_NTOHL((int) (CommandStatus.ReturnValue)) );
					*(CommandStatus.Errstr+sizeof(CommandStatus.Errstr)-1)='\0';
					printf("Remote errno: %d (%s)\n",(int)MODBUS_NTOHL((int)CommandStatus.Syserrno),CommandStatus.Errstr);
					return -1;
					break;
				default:
					printf("remote system returned a MODBUS exception for command MSXE321x__TemperatureSetChannelType\n");
					printf("reason: %s (%d)\n",modbus_exception_to_str(modbus->exception),modbus->exception);
					return -1;
					break;
			}
			break;
		case -3: // incorrect response from remote system
			printf("incorrect response from remote system\n");
			return -1;
			break;
		case -4: 
			printf("remote system returned a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed\n");
			return -1;
			break;
		default: 
			printf("unknown return code %d from MSXE321x__TemperatureSetChannelType()\n",ret);
			return -1;
			break;
	}
	printf("call to MSXE321x__TemperatureSetChannelType OK\n");
	return 0;
}

*/

int modbus_call_MSXE321x__TemperatureSetChannelType(struct modbus * modbus,
	uint32_t ulChannel,
	uint32_t ulType,
	uint32_t ulOption1
, struct GetLastCommandStatus_parameters_t * CommandStatus);

/** <p>Temperature acquisition sampling rate selection</p>
*<p><b>Parameters:</b></p>
* <ul>
* <p>@param[in] <b><VAR> ulChannelGroup </VAR></b> Channel group selection.<ul>
*                       <li> 0 for channels 0 and 1
*			<li> 1 for channels 2 and 3
*			<li> 2 for channels 4 and 5
*			<li> 3 for channels 6 and 7
*			<li> 4 for channels 8 and 9
*			<li> 5 for channels 10 and 11
*			<li> 6 for channels 12 and 13
*			<li> 7 for channels 14 and 15
*			<li> ...
*			<li> 255 for all channels</ul></p>
* <p>@param[in] <b><VAR> ulBaseSamplingRate </VAR></b> Sampling rate selection<ul>
*			<li> 5 for 5Hz
*			<li> 10 for 10Hz
*			<li> 20 for 20Hz
*			<li> 40 for 40Hz
*			<li> 80 for 80Hz
*			<li> 160 for 160Hz
*			<li> 320 for 320Hz
*			<li> 640 for 640Hz
*			<li> 1000 for 1000Hz
*			<li> 2000 for 2000Hz</ul></p>
* <p>@param[in] <b><VAR> ulOption1 </VAR></b> Reserved. Set to 0</p>
*
* </ul>
* <p><b> Returns:</b></p>
* <ul>
* @return <b>Possible return value on the remote system (read them with GetLastCommandStatus)</b>
* <ul>
* <li><b> <VAR>syserrno :</VAR> </b> system-error code (the value of the libc "errno" code) EPERM means a autorefresh acquisition was not started.
* </ul></ul>
*/
		
/*
@return 0 on success, -1 on system error, -2 on MODBUS exception (the exception code is in modbus->exception), -3 if response from remote system is incorrect, -4 if the remote call generated a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed
*/

/* Below is an example on how this function is intended to be used

int sample_MSXE321x__TemperatureSetSamplingRate(struct modbus * modbus)
{

	//variables declaration

	struct GetLastCommandStatus_parameters_t CommandStatus;
	int ret = 0;
	uint32_t ulChannelGroup;
	uint32_t ulBaseSamplingRate;
	uint32_t ulOption1;

	//Initialise variables here

	//Remote function call
	ret = modbus_call_MSXE321x__TemperatureSetSamplingRate(modbus,ulChannelGroup,ulBaseSamplingRate,ulOption1,&CommandStatus);

	//Return value check
	switch(ret)
	{
		case 0: // OK
			break;
		case -1: // system error
			perror("MSXE321x__TemperatureSetSamplingRate");
			return -1;
			break;
		case -2: // MODBUS exception
			switch(modbus->exception)
			{
				case MODBUS_REMOTE_EXECUTION_ERROR: // actually a remote exception error and we get it in CommandStatus
					printf("Remote command returned: %d\n",MODBUS_NTOHL((int) (CommandStatus.ReturnValue)) );
					*(CommandStatus.Errstr+sizeof(CommandStatus.Errstr)-1)='\0';
					printf("Remote errno: %d (%s)\n",(int)MODBUS_NTOHL((int)CommandStatus.Syserrno),CommandStatus.Errstr);
					return -1;
					break;
				default:
					printf("remote system returned a MODBUS exception for command MSXE321x__TemperatureSetSamplingRate\n");
					printf("reason: %s (%d)\n",modbus_exception_to_str(modbus->exception),modbus->exception);
					return -1;
					break;
			}
			break;
		case -3: // incorrect response from remote system
			printf("incorrect response from remote system\n");
			return -1;
			break;
		case -4: 
			printf("remote system returned a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed\n");
			return -1;
			break;
		default: 
			printf("unknown return code %d from MSXE321x__TemperatureSetSamplingRate()\n",ret);
			return -1;
			break;
	}
	printf("call to MSXE321x__TemperatureSetSamplingRate OK\n");
	return 0;
}

*/

int modbus_call_MSXE321x__TemperatureSetSamplingRate(struct modbus * modbus,
	uint32_t ulChannelGroup,
	uint32_t ulBaseSamplingRate,
	uint32_t ulOption1
, struct GetLastCommandStatus_parameters_t * CommandStatus);

/** <p>This function start the calibration thread</p>
*<p><b>Parameters:</b></p>
* <ul>
* <p>@param[in] <b><VAR> ulChannelGroup </VAR></b> Channel group selection.<ul>
*                       <li> 0 for channels 0 and 1
*			<li> 1 for channels 2 and 3
*			<li> 2 for channels 4 and 5
*			<li> 3 for channels 6 and 7
*			<li> 4 for channels 8 and 9
*			<li> 5 for channels 10 and 11
*			<li> 6 for channels 12 and 13
*			<li> 7 for channels 14 and 15
*			<li> ...</ul></p>
* <p>@param[in] <b><VAR> ulGainSelection </VAR></b>Selected gain (1, 2, 4, 8, 16, 32, 64 or 128)</p>
* <p>@param[in] <b><VAR> ulNbrOfRefValues </VAR></b> Nbr of channel reference values used for the calibration (Max 16)</p>
* <p>@param[in] <b><VAR> fRefValues </VAR></b> Reference voltage values for the calibration (Max 16)</p>
*
* </ul>
* <p><b> Returns:</b></p>
* <ul>
* @return <b>Possible return value on the remote system (read them with GetLastCommandStatus)</b>
* <ul>
* <li><b> <VAR>syserrno :</VAR> </b> system-error code (the value of the libc "errno" code) EPERM means a autorefresh acquisition was not started.
* </ul></ul>
*/
			
/*
@return 0 on success, -1 on system error, -2 on MODBUS exception (the exception code is in modbus->exception), -3 if response from remote system is incorrect, -4 if the remote call generated a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed
*/

/* Below is an example on how this function is intended to be used

int sample_MSXE321x__TemperatureCalibrationStart(struct modbus * modbus)
{

	//variables declaration

	struct GetLastCommandStatus_parameters_t CommandStatus;
	int ret = 0;
	uint32_t ulChannelGroup;
	uint32_t ulGainSelection;
	uint32_t ulNbrOfRefValues;
	float fRefValues[16];

	//Initialise variables here

	//Remote function call
	ret = modbus_call_MSXE321x__TemperatureCalibrationStart(modbus,ulChannelGroup,ulGainSelection,ulNbrOfRefValues,fRefValues,&CommandStatus);

	//Return value check
	switch(ret)
	{
		case 0: // OK
			break;
		case -1: // system error
			perror("MSXE321x__TemperatureCalibrationStart");
			return -1;
			break;
		case -2: // MODBUS exception
			switch(modbus->exception)
			{
				case MODBUS_REMOTE_EXECUTION_ERROR: // actually a remote exception error and we get it in CommandStatus
					printf("Remote command returned: %d\n",MODBUS_NTOHL((int) (CommandStatus.ReturnValue)) );
					*(CommandStatus.Errstr+sizeof(CommandStatus.Errstr)-1)='\0';
					printf("Remote errno: %d (%s)\n",(int)MODBUS_NTOHL((int)CommandStatus.Syserrno),CommandStatus.Errstr);
					return -1;
					break;
				default:
					printf("remote system returned a MODBUS exception for command MSXE321x__TemperatureCalibrationStart\n");
					printf("reason: %s (%d)\n",modbus_exception_to_str(modbus->exception),modbus->exception);
					return -1;
					break;
			}
			break;
		case -3: // incorrect response from remote system
			printf("incorrect response from remote system\n");
			return -1;
			break;
		case -4: 
			printf("remote system returned a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed\n");
			return -1;
			break;
		default: 
			printf("unknown return code %d from MSXE321x__TemperatureCalibrationStart()\n",ret);
			return -1;
			break;
	}
	printf("call to MSXE321x__TemperatureCalibrationStart OK\n");
	return 0;
}

*/

int modbus_call_MSXE321x__TemperatureCalibrationStart(struct modbus * modbus,
	uint32_t ulChannelGroup,
	uint32_t ulGainSelection,
	uint32_t ulNbrOfRefValues,
	float fRefValues[16]
, struct GetLastCommandStatus_parameters_t * CommandStatus);

/** <p>This function start the next calibration step</p>
*<p><b>Parameters:</b></p>
* <ul>
* <p>@param[in] <b><VAR> ulOption1 </VAR></b> Reserved. Set to 0</p>
*
* </ul>
* <p><b> Returns:</b></p>
* <ul>
* @return <b>Possible return value on the remote system (read them with GetLastCommandStatus)</b>
* <ul>
* <li><b> <VAR>syserrno :</VAR> </b> system-error code (the value of the libc "errno" code) EPERM means a autorefresh acquisition was not started.
* </ul></ul>
*/
			
/*
@return 0 on success, -1 on system error, -2 on MODBUS exception (the exception code is in modbus->exception), -3 if response from remote system is incorrect, -4 if the remote call generated a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed
*/

/* Below is an example on how this function is intended to be used

int sample_MSXE321x__TemperatureCalibrationNextStep(struct modbus * modbus)
{

	//variables declaration

	struct GetLastCommandStatus_parameters_t CommandStatus;
	int ret = 0;
	uint32_t ulOption01;

	//Initialise variables here

	//Remote function call
	ret = modbus_call_MSXE321x__TemperatureCalibrationNextStep(modbus,ulOption01,&CommandStatus);

	//Return value check
	switch(ret)
	{
		case 0: // OK
			break;
		case -1: // system error
			perror("MSXE321x__TemperatureCalibrationNextStep");
			return -1;
			break;
		case -2: // MODBUS exception
			switch(modbus->exception)
			{
				case MODBUS_REMOTE_EXECUTION_ERROR: // actually a remote exception error and we get it in CommandStatus
					printf("Remote command returned: %d\n",MODBUS_NTOHL((int) (CommandStatus.ReturnValue)) );
					*(CommandStatus.Errstr+sizeof(CommandStatus.Errstr)-1)='\0';
					printf("Remote errno: %d (%s)\n",(int)MODBUS_NTOHL((int)CommandStatus.Syserrno),CommandStatus.Errstr);
					return -1;
					break;
				default:
					printf("remote system returned a MODBUS exception for command MSXE321x__TemperatureCalibrationNextStep\n");
					printf("reason: %s (%d)\n",modbus_exception_to_str(modbus->exception),modbus->exception);
					return -1;
					break;
			}
			break;
		case -3: // incorrect response from remote system
			printf("incorrect response from remote system\n");
			return -1;
			break;
		case -4: 
			printf("remote system returned a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed\n");
			return -1;
			break;
		default: 
			printf("unknown return code %d from MSXE321x__TemperatureCalibrationNextStep()\n",ret);
			return -1;
			break;
	}
	printf("call to MSXE321x__TemperatureCalibrationNextStep OK\n");
	return 0;
}

*/

int modbus_call_MSXE321x__TemperatureCalibrationNextStep(struct modbus * modbus,
	uint32_t ulOption01
, struct GetLastCommandStatus_parameters_t * CommandStatus);

/** <p>This function break the current calibration</p>
*<p><b>Parameters:</b></p>
* <ul>
* <p>@param[in] <b><VAR> ulOption1 </VAR></b> Reserved. Set to 0</p>
*
* </ul>
* <p><b> Returns:</b></p>
* <ul>
* @return <b>Possible return value on the remote system (read them with GetLastCommandStatus)</b>
* <ul>
* <li><b> <VAR>syserrno :</VAR> </b> system-error code (the value of the libc "errno" code) EPERM means a autorefresh acquisition was not started.
* </ul></ul>
*/
			
/*
@return 0 on success, -1 on system error, -2 on MODBUS exception (the exception code is in modbus->exception), -3 if response from remote system is incorrect, -4 if the remote call generated a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed
*/

/* Below is an example on how this function is intended to be used

int sample_MSXE321x__TemperatureCalibrationBreak(struct modbus * modbus)
{

	//variables declaration

	struct GetLastCommandStatus_parameters_t CommandStatus;
	int ret = 0;
	uint32_t ulOption01;

	//Initialise variables here

	//Remote function call
	ret = modbus_call_MSXE321x__TemperatureCalibrationBreak(modbus,ulOption01,&CommandStatus);

	//Return value check
	switch(ret)
	{
		case 0: // OK
			break;
		case -1: // system error
			perror("MSXE321x__TemperatureCalibrationBreak");
			return -1;
			break;
		case -2: // MODBUS exception
			switch(modbus->exception)
			{
				case MODBUS_REMOTE_EXECUTION_ERROR: // actually a remote exception error and we get it in CommandStatus
					printf("Remote command returned: %d\n",MODBUS_NTOHL((int) (CommandStatus.ReturnValue)) );
					*(CommandStatus.Errstr+sizeof(CommandStatus.Errstr)-1)='\0';
					printf("Remote errno: %d (%s)\n",(int)MODBUS_NTOHL((int)CommandStatus.Syserrno),CommandStatus.Errstr);
					return -1;
					break;
				default:
					printf("remote system returned a MODBUS exception for command MSXE321x__TemperatureCalibrationBreak\n");
					printf("reason: %s (%d)\n",modbus_exception_to_str(modbus->exception),modbus->exception);
					return -1;
					break;
			}
			break;
		case -3: // incorrect response from remote system
			printf("incorrect response from remote system\n");
			return -1;
			break;
		case -4: 
			printf("remote system returned a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed\n");
			return -1;
			break;
		default: 
			printf("unknown return code %d from MSXE321x__TemperatureCalibrationBreak()\n",ret);
			return -1;
			break;
	}
	printf("call to MSXE321x__TemperatureCalibrationBreak OK\n");
	return 0;
}

*/

int modbus_call_MSXE321x__TemperatureCalibrationBreak(struct modbus * modbus,
	uint32_t ulOption01
, struct GetLastCommandStatus_parameters_t * CommandStatus);

/** <p>Initialise and start an auto refresh acquisition using provided configuration</p>
* <p><b>Parameters</b></p>
* <ul>
* 	<li>@param[in] <b><VAR> ulChannelMask </VAR></b> Mask of the channel to acquire by the auto refresh (1 bit = 1 Channel). 0 for all available acquisition channels </li>
* 	<li>@param[in] <b><VAR> ulAverageValue </VAR></b> Set the average value
*		<ul>
*			<li> 1 : not used</li>
*			<li> max value : 255</li>
*		</ul>
*	</li>
* 	<li>@param[in] <b><VAR> ulRefreshTimeUnit </VAR></b> Refresh Time Unit
*		<ul>
*			<li> 0 : microsecond</li>
*			<li> 1 : millisecond</li>
*			<li> 2 : second </li>
*		</ul>
*	</li>
* 	<li>@param[in] <b><VAR> ulRefreshTime </VAR></b> Refresh Time
*		<ul>
*			<li> range from min 1000 to 65535 when the unit is the microsecond</li>
*			<li> range from min 1 to 65535 when the unit is the millisecond</li>
*			<li> range from min 1 to 65535 when the unit is the second</li>
*		</ul>
*	</li>
* 	<li>@param[in] <b><VAR> ulTriggerMask </VAR></b> Define the source of the trigger
*		<ul>
*			<li> 0 : trigger disabled</li>
*			<li> 1 : Enable Hardware Digital Input Trigger</li>
*			<li> 2 : Enable Synchro Trigger </li>
*			<li> 4 : Enable Compare Trigger (only useful if your system has incremental counter or Sine/Cosine input) </li>
*			<li> 8 : Enable Index Trigger (only useful if your system has Sine/Cosine input)</li>
*		</ul>
*	</li>
* 	<li>@param[in] <b><VAR> ulTriggerMode </VAR></b> Define the trigger mode
*		<ul>
*			<li> 1 : One shot trigger</li>
*			<li> 2 : Sequence trigger </li>
*		</ul>
*	</li>
* 	<li>@param[in] <b><VAR> ulHardwareTriggerEdge </VAR></b> Define the edge of the hardware trigger who generates a trigger action
*		<ul>
*			<li> 1 : rising edge (Only if hardware trigger selected)</li>
*			<li> 2 : falling edge (Only if hardware trigger selected)</li>
*			<li> 3 : Both front (Only if hardware trigger selected) </li>
*		</ul>
*	</li>
* 	<li>@param[in] <b><VAR> ulHardwareTriggerCount </VAR></b> Define the number of trigger events before the action occur
*		<ul>
*			<li> 1 : all trigger event start the action</li>
*			<li> max value : 65535 </li>
*		</ul>
*	</li>
* 	<li>@param[in] <b><VAR> ulByTriggerNbrOfSeqToAcquire </VAR></b> Define the number of sequence to acquire by each trigger event
*		<ul>
*			<li> 0 : continuous mode</li>
*			<li> 0 : number of sequence : (1..0xFFFFFFFF) </li>
*		</ul>
*	</li>
* 	<li>@param[in] <b><VAR> ulDataFormat </VAR></b>
*		<ul>
*			<li> D0 : Absolute time stamp information
*				<ul>
*					<li> 0: no time stamp information</li>
*					<li> 1: time stamp information </li>
*				</ul>
*			</li>
*			<li> D1 : Relative time stamp information
*				<ul>
*					<li> 0: no time stamp information</li>
*					<li> 1: time stamp information </li>
*				</ul>
*			</li>
*			<li> D2 : Auto refresh counter information
*				<ul>
*					<li>  0 : No auto refresh counter information</li>
*					<li>  1 : Auto refresh counter information </li>
*				</ul>
*			</li>
*			<li> D3 : System status information
*				<ul>
*					<li>  0 : No system status information required</li>
*					<li>  1 : System status information required</li>
*				</ul>
*			</li>
*			<li> D4 : Data format
*				<ul>
*					<li> 0: Digital value</li>
*					<li> 1: Analog value </li>
*				</ul>
*			</li>
*		</ul>
*	</li>
* 	<li>@param[in] <b><VAR> ulForceStart </VAR></b>
*		<ul>
*			<li> 0 : Function return a error if any acquisition already in progress</li>
*			<li> 1 : If any acquisition in progress then stop this </li>
*		</ul>
*	</li>
* 	<li>@param[in] <b><VAR> ulOption1 </VAR></b> Reserved. Set to 0</li>
* 	<li>@param[in] <b><VAR> ulOption2 </VAR></b> Reserved. Set to 0</li>
* 	<li>@param[in] <b><VAR> ulOption3 </VAR></b> Reserved. Set to 0</li>
* </ul>
* <p><b> Returns:</b></p>
* <p>Possible return value on the remote system (read them with GetLastCommandStatus).</p>
* <ul>
*	<li><b>0</b> The remote function performed OK</li>
*	<li><b>-2</b> Any acquisition already in progress</li>
*	<li><b>-3</b> Any selected channel not OK, call the diagnostic function for more information</li>
*	<li><b>-4</b> Channel Mask error</li>
*	<li><b>-5</b> Not available average value</li>
*	<li><b>-6</b> Not available refresh time unit</li>
*	<li><b>-7</b> The minimal refresh time is 1000 us</li>
*	<li><b>-8</b> The maximal refresh time is 65535</li>
*	<li><b>-9</b> Trigger mask not available</li>
*	<li><b>-10</b> Trigger mask : 2 different trigger source cannot be simultaneously be activated</li>
*	<li><b>-11</b> Trigger mode not available</li>
*	<li><b>-12</b> Trigger mask : 2 trigger mode cannot be simultaneously activated</li>
*	<li><b>-13</b> Hardware trigger : front definition error</li>
*	<li><b>-14</b> Hardware trigger count value not available</li>
*	<li><b>-15</b> Nbr of sequence to acquire by trigger mode not available</li>
*	<li><b>-16</b> Data format not available</li>
*	<li><b>-17</b> Selected channels combination not available</li>
*	<li><b>-100</b> Internal system error occurred. See value of syserrno</li>
* </ul>
*/
		
/*
@return 0 on success, -1 on system error, -2 on MODBUS exception (the exception code is in modbus->exception), -3 if response from remote system is incorrect, -4 if the remote call generated a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed
*/

/* Below is an example on how this function is intended to be used

int sample_MSXE321x__AcquisitionAutoRefreshInitAndStart(struct modbus * modbus)
{

	//variables declaration

	struct GetLastCommandStatus_parameters_t CommandStatus;
	int ret = 0;
	uint32_t ulChannelMask;
	uint32_t ulAverageValue;
	uint32_t ulRefreshTime;
	uint32_t ulRefreshTimeUnit;
	uint32_t ulTriggerMask;
	uint32_t ulTriggerMode;
	uint32_t ulHardwareTriggerEdge;
	uint32_t ulHardwareTriggerCount;
	uint32_t ulByTriggerNbrOfSeqToAcquire;
	uint32_t ulDataFormat;
	uint32_t ulForceStart;
	uint32_t ulOption1;
	uint32_t ulOption2;
	uint32_t ulOption3;

	//Initialise variables here

	//Remote function call
	ret = modbus_call_MSXE321x__AcquisitionAutoRefreshInitAndStart(modbus,ulChannelMask,ulAverageValue,ulRefreshTime,ulRefreshTimeUnit,ulTriggerMask,ulTriggerMode,ulHardwareTriggerEdge,ulHardwareTriggerCount,ulByTriggerNbrOfSeqToAcquire,ulDataFormat,ulForceStart,ulOption1,ulOption2,ulOption3,&CommandStatus);

	//Return value check
	switch(ret)
	{
		case 0: // OK
			break;
		case -1: // system error
			perror("MSXE321x__AcquisitionAutoRefreshInitAndStart");
			return -1;
			break;
		case -2: // MODBUS exception
			switch(modbus->exception)
			{
				case MODBUS_REMOTE_EXECUTION_ERROR: // actually a remote exception error and we get it in CommandStatus
					printf("Remote command returned: %d\n",MODBUS_NTOHL((int) (CommandStatus.ReturnValue)) );
					*(CommandStatus.Errstr+sizeof(CommandStatus.Errstr)-1)='\0';
					printf("Remote errno: %d (%s)\n",(int)MODBUS_NTOHL((int)CommandStatus.Syserrno),CommandStatus.Errstr);
					return -1;
					break;
				default:
					printf("remote system returned a MODBUS exception for command MSXE321x__AcquisitionAutoRefreshInitAndStart\n");
					printf("reason: %s (%d)\n",modbus_exception_to_str(modbus->exception),modbus->exception);
					return -1;
					break;
			}
			break;
		case -3: // incorrect response from remote system
			printf("incorrect response from remote system\n");
			return -1;
			break;
		case -4: 
			printf("remote system returned a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed\n");
			return -1;
			break;
		default: 
			printf("unknown return code %d from MSXE321x__AcquisitionAutoRefreshInitAndStart()\n",ret);
			return -1;
			break;
	}
	printf("call to MSXE321x__AcquisitionAutoRefreshInitAndStart OK\n");
	return 0;
}

*/

int modbus_call_MSXE321x__AcquisitionAutoRefreshInitAndStart(struct modbus * modbus,
	uint32_t ulChannelMask,
	uint32_t ulAverageValue,
	uint32_t ulRefreshTime,
	uint32_t ulRefreshTimeUnit,
	uint32_t ulTriggerMask,
	uint32_t ulTriggerMode,
	uint32_t ulHardwareTriggerEdge,
	uint32_t ulHardwareTriggerCount,
	uint32_t ulByTriggerNbrOfSeqToAcquire,
	uint32_t ulDataFormat,
	uint32_t ulForceStart,
	uint32_t ulOption1,
	uint32_t ulOption2,
	uint32_t ulOption3
, struct GetLastCommandStatus_parameters_t * CommandStatus);

/** <p> Stops the current auto refresh acquisition</p>
* <p><b>Parameters</b></p>
* <ul>
* 	<li>@param[in] <b><VAR> ulOption1 </VAR></b> Reserved. Set to 0</li>
* </ul>
* <p><b> Returns:</b></p>
* <p>Possible return value on the remote system (read them with GetLastCommandStatus).</p>
* <ul>
*	<li><b>0</b> The remote function performed OK</li>
*	<li><b>-100</b> Internal system error occurred. See value of syserrno</li>
* </ul>
*/
		
/*
@return 0 on success, -1 on system error, -2 on MODBUS exception (the exception code is in modbus->exception), -3 if response from remote system is incorrect, -4 if the remote call generated a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed
*/

/* Below is an example on how this function is intended to be used

int sample_MSXE321x__AcquisitionAutoRefreshStopAndRelease(struct modbus * modbus)
{

	//variables declaration

	struct GetLastCommandStatus_parameters_t CommandStatus;
	int ret = 0;
	uint32_t ulOption1;

	//Initialise variables here

	//Remote function call
	ret = modbus_call_MSXE321x__AcquisitionAutoRefreshStopAndRelease(modbus,ulOption1,&CommandStatus);

	//Return value check
	switch(ret)
	{
		case 0: // OK
			break;
		case -1: // system error
			perror("MSXE321x__AcquisitionAutoRefreshStopAndRelease");
			return -1;
			break;
		case -2: // MODBUS exception
			switch(modbus->exception)
			{
				case MODBUS_REMOTE_EXECUTION_ERROR: // actually a remote exception error and we get it in CommandStatus
					printf("Remote command returned: %d\n",MODBUS_NTOHL((int) (CommandStatus.ReturnValue)) );
					*(CommandStatus.Errstr+sizeof(CommandStatus.Errstr)-1)='\0';
					printf("Remote errno: %d (%s)\n",(int)MODBUS_NTOHL((int)CommandStatus.Syserrno),CommandStatus.Errstr);
					return -1;
					break;
				default:
					printf("remote system returned a MODBUS exception for command MSXE321x__AcquisitionAutoRefreshStopAndRelease\n");
					printf("reason: %s (%d)\n",modbus_exception_to_str(modbus->exception),modbus->exception);
					return -1;
					break;
			}
			break;
		case -3: // incorrect response from remote system
			printf("incorrect response from remote system\n");
			return -1;
			break;
		case -4: 
			printf("remote system returned a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed\n");
			return -1;
			break;
		default: 
			printf("unknown return code %d from MSXE321x__AcquisitionAutoRefreshStopAndRelease()\n",ret);
			return -1;
			break;
	}
	printf("call to MSXE321x__AcquisitionAutoRefreshStopAndRelease OK\n");
	return 0;
}

*/

int modbus_call_MSXE321x__AcquisitionAutoRefreshStopAndRelease(struct modbus * modbus,
	uint32_t ulOption1
, struct GetLastCommandStatus_parameters_t * CommandStatus);

/** <p>Initialise and start the sequence acquisition mode</p>
*<p><b>Parameters</b></p>
* <ul>
* 	<li>@param[in] <b><VAR> ulNbrOfChannel </VAR></b> Number of channel in the sequence</li>
* 	<li>@param[in] <b><VAR> psChannelList </VAR></b> List of the channel who compose the sequence.</li>
* 	<li>@param[in] <b><VAR> ulAcquisitionTime </VAR></b> Acquisition Time
*		<ul>
*			<li> range from min 1000 to 65535 when the unit is the microsecond</li>
*			<li> range from min 1 to 65535 when the unit is the millisecond</li>
*			<li> range from min 1 to 65535 when the unit is the second </li>
*		</ul>
*	</li>
* 	<li>@param[in] <b><VAR> ulAcquisitionTimeUnit </VAR></b> Acquisition Time Unit
*		<ul>
*			<li> 0 : us</li>
*			<li> 1 : ms</li>
*			<li> 2 : s </li>
*		</ul>
*	</li>
* 	<li>@param[in] <b><VAR> ulNbrOfSequence </VAR></b> Number of sequence to acquire
*		<ul>
*			<li> 0 : continuous mode</li>
*			<li> Superior to 0 : number of sequence </li>
*		</ul>
*	</li>
* 	<li>@param[in] <b><VAR> ulNbrMaxSequenceToTransfer </VAR></b> Max number of sequence to acquire before a data transfer. (from 1 to 65535)</li>
* 	<li>@param[in] <b><VAR> ulTriggerMask </VAR></b> Define the source of the trigger
*		<ul>
*			<li> 0 : trigger disabled</li>
*			<li> 1 : Enable Hardware Digital Input Trigger</li>
*			<li> 2 : Enable Synchro Trigger</li>
*			<li> 4 : Enable Compare Trigger (only useful if your system has incremental counter or Sine/Cosine input)</li>
*			<li> 8 : Enable Index Trigger (only useful if your system has Sine/Cosine input)</li>
*		</ul>
*	</li>
* 	<li>@param[in] <b><VAR> ulTriggerMode </VAR></b> Define the trigger mode
*		<ul>
*			<li> 1 : One shot trigger</li>
*			<li> 2 : Sequence trigger </li>
*		</ul>
*	</li>
* 	<li>@param[in] <b><VAR> ulHardwareTriggerEdge </VAR></b> Define the edge of the hardware trigger who generate a trigger action
*		<ul>
*			<li> 1 : rising front (Only if hardware trigger selected)</li>
*			<li> 2 : falling front (Only if hardware trigger selected)</li>
*			<li> 3 : Both front (Only if hardware trigger selected) </li>
*		</ul>
*	</li>
* 	<li>@param[in] <b><VAR> ulHardwareTriggerCount </VAR></b> Define the number of trigger events before the action occur
*		<ul>
*			<li> 1 : all trigger event start the action</li>
*			<li> max value : 65535 </li>
*		</ul>
*	</li>
* 	<li>@param[in] <b><VAR> ulByTriggerNbrOfSeqToAcquire </VAR></b> define the number of sequence to acquire by each trigger event
*		<ul>
*			<li> 0 : continuous mode</li>
*			<li> Superior to 0 : number of sequence : (1..0xFFFFFFFF) </li>
*		</ul>
*	</li>
* 	<li>@param[in] <b><VAR> ulDataFormat </VAR></b> Data format option
*		<ul>
*			<li> D0 : Absolute time stamp information
*				<ul>
*					<li> 0: no time stamp information</li>
*					<li> 1: time stamp information</li>
*				</ul>
*			</li>
*			<li> D1 : Relative time stamp information
*				<ul>
*					<li> 0: no time stamp information</li>
*					<li> 1: time stamp information </li>
*				</ul>
*			</li>
*			<li> D2 : Sequence counter information
*				<ul>
*					<li> 0 : No sequence counter information</li>
*					<li> 1 : Sequence counter information </li>
*				</ul>
*			</li>
*			<li> D3 : System status information
*				<ul>
*					<li>  0 : No system status information required</li>
*					<li>  1 : System status information required</li>
*				</ul>
*			</li>
*			<li> D4 : Data format
*				<ul>
*					<li> 0: Digital value</li>
*					<li> 1: Analog value </li>
*				</ul>
*			</li>
*		</ul>
*	</li>
* 	<li>@param[in] <b><VAR> ulForceStart </VAR></b>
*		<ul>
*			<li> 0 : Function return a error if any acquisition already in progress</li>
*			<li> 1 : If any acquisition in progress then stop this </li>
*		</ul>
*	</li>
* 	<li>@param[in] <b><VAR> ulOption1 </VAR></b> Reserved. Set to 0</li>
* 	<li>@param[in] <b><VAR> ulOption2 </VAR></b> Reserved. Set to 0</li>
* 	<li>@param[in] <b><VAR> ulOption3 </VAR></b> Reserved. Set to 0</li>
* </ul>
* <p><b> Returns:</b></p>
* <p>Possible return value on the remote system (read them with GetLastCommandStatus).</p>
* <ul>
*	<li><b>0</b> The remote function performed OK</li>
*	<li><b>-2</b> Any acquisition already in progress</li>
*	<li><b>-3</b> The number of channel in the sequence is null or to high</li>
*	<li><b>-4</b> Channel index selection error</li>
*	<li><b>-5</b> Channel already selected</li>
*	<li><b>-6</b> Any selected channel not OK, call the diagnostic function for more information</li>
*	<li><b>-7</b> Not available acquisition time unit</li>
*	<li><b>-8</b> The minimal acquisition time is 1000 us !</li>
*	<li><b>-9</b> The maximal acquisition time is 65535 !</li>
*	<li><b>-10</b> Transfer sequence size error (1 to 4096) !</li>
*	<li><b>-11</b> The total number of sequences is not a multiple from number of sequences to transfer</li>
*	<li><b>-12</b> Trigger mask not available</li>
*	<li><b>-13</b> Trigger mask : 2 different trigger source cannot be simultaneously be activated</li>
*	<li><b>-14</b> Trigger mode not available</li>
*	<li><b>-15</b> Trigger mask : 2 trigger mode cannot be simultaneously be activated</li>
*	<li><b>-16</b> Hardware trigger : front definition error</li>
*	<li><b>-17</b> Hardware trigger count value not available</li>
*	<li><b>-18</b> Number of sequence to acquire by trigger mode not available</li>
*	<li><b>-19</b> Data format not available</li>
*	<li><b>-20</b> Selected channels combination not available</li>
*	<li><b>-100</b> Internal system error occurred. See value of syserrno</li>
* </ul>
*/
			
/*
@return 0 on success, -1 on system error, -2 on MODBUS exception (the exception code is in modbus->exception), -3 if response from remote system is incorrect, -4 if the remote call generated a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed
*/

/* Below is an example on how this function is intended to be used

int sample_MSXE321x__AcquisitionSequenceInitAndStart(struct modbus * modbus)
{

	//variables declaration

	struct GetLastCommandStatus_parameters_t CommandStatus;
	int ret = 0;
	uint32_t ulNbrOfChannel;
	uint32_t ulChannelList[16];
	uint32_t ulAcquisitionTime;
	uint32_t ulAcquisitionTimeUnit;
	uint32_t ulNbrOfSequence;
	uint32_t ulNbrMaxSequenceToTransfer;
	uint32_t ulTriggerMask;
	uint32_t ulTriggerMode;
	uint32_t ulHardwareTriggerEdge;
	uint32_t ulHardwareTriggerCount;
	uint32_t ulByTriggerNbrOfSeqToAcquire;
	uint32_t ulDataFormat;
	uint32_t ulForceStart;
	uint32_t ulOption1;
	uint32_t ulOption2;
	uint32_t ulOption3;

	//Initialise variables here

	//Remote function call
	ret = modbus_call_MSXE321x__AcquisitionSequenceInitAndStart(modbus,ulNbrOfChannel,ulChannelList,ulAcquisitionTime,ulAcquisitionTimeUnit,ulNbrOfSequence,ulNbrMaxSequenceToTransfer,ulTriggerMask,ulTriggerMode,ulHardwareTriggerEdge,ulHardwareTriggerCount,ulByTriggerNbrOfSeqToAcquire,ulDataFormat,ulForceStart,ulOption1,ulOption2,ulOption3,&CommandStatus);

	//Return value check
	switch(ret)
	{
		case 0: // OK
			break;
		case -1: // system error
			perror("MSXE321x__AcquisitionSequenceInitAndStart");
			return -1;
			break;
		case -2: // MODBUS exception
			switch(modbus->exception)
			{
				case MODBUS_REMOTE_EXECUTION_ERROR: // actually a remote exception error and we get it in CommandStatus
					printf("Remote command returned: %d\n",MODBUS_NTOHL((int) (CommandStatus.ReturnValue)) );
					*(CommandStatus.Errstr+sizeof(CommandStatus.Errstr)-1)='\0';
					printf("Remote errno: %d (%s)\n",(int)MODBUS_NTOHL((int)CommandStatus.Syserrno),CommandStatus.Errstr);
					return -1;
					break;
				default:
					printf("remote system returned a MODBUS exception for command MSXE321x__AcquisitionSequenceInitAndStart\n");
					printf("reason: %s (%d)\n",modbus_exception_to_str(modbus->exception),modbus->exception);
					return -1;
					break;
			}
			break;
		case -3: // incorrect response from remote system
			printf("incorrect response from remote system\n");
			return -1;
			break;
		case -4: 
			printf("remote system returned a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed\n");
			return -1;
			break;
		default: 
			printf("unknown return code %d from MSXE321x__AcquisitionSequenceInitAndStart()\n",ret);
			return -1;
			break;
	}
	printf("call to MSXE321x__AcquisitionSequenceInitAndStart OK\n");
	return 0;
}

*/

int modbus_call_MSXE321x__AcquisitionSequenceInitAndStart(struct modbus * modbus,
	uint32_t ulNbrOfChannel,
	uint32_t ulChannelList[16],
	uint32_t ulAcquisitionTime,
	uint32_t ulAcquisitionTimeUnit,
	uint32_t ulNbrOfSequence,
	uint32_t ulNbrMaxSequenceToTransfer,
	uint32_t ulTriggerMask,
	uint32_t ulTriggerMode,
	uint32_t ulHardwareTriggerEdge,
	uint32_t ulHardwareTriggerCount,
	uint32_t ulByTriggerNbrOfSeqToAcquire,
	uint32_t ulDataFormat,
	uint32_t ulForceStart,
	uint32_t ulOption1,
	uint32_t ulOption2,
	uint32_t ulOption3
, struct GetLastCommandStatus_parameters_t * CommandStatus);

/** <p>Stop and release the sequence acquisition mode</p>
* <p><b>Parameters</b></p>
* <ul>
* 	<li>@param[in] <b><VAR> ulOption1 </VAR></b> Reserved. Set to 0</li>
* </ul>
* <p><b> Returns:</b></p>
* <p>Possible return value on the remote system (read them with GetLastCommandStatus).</p>
* <ul>
*	<li><b>0</b> The remote function performed OK</li>
*	<li><b>-2</b> No sequence acquisition in progress</li>
*	<li><b>-100</b> Internal system error occurred. See value of syserrno</li>
* </ul>
*/
			
/*
@return 0 on success, -1 on system error, -2 on MODBUS exception (the exception code is in modbus->exception), -3 if response from remote system is incorrect, -4 if the remote call generated a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed
*/

/* Below is an example on how this function is intended to be used

int sample_MSXE321x__AcquisitionSequenceStopAndRelease(struct modbus * modbus)
{

	//variables declaration

	struct GetLastCommandStatus_parameters_t CommandStatus;
	int ret = 0;
	uint32_t ulOption01;

	//Initialise variables here

	//Remote function call
	ret = modbus_call_MSXE321x__AcquisitionSequenceStopAndRelease(modbus,ulOption01,&CommandStatus);

	//Return value check
	switch(ret)
	{
		case 0: // OK
			break;
		case -1: // system error
			perror("MSXE321x__AcquisitionSequenceStopAndRelease");
			return -1;
			break;
		case -2: // MODBUS exception
			switch(modbus->exception)
			{
				case MODBUS_REMOTE_EXECUTION_ERROR: // actually a remote exception error and we get it in CommandStatus
					printf("Remote command returned: %d\n",MODBUS_NTOHL((int) (CommandStatus.ReturnValue)) );
					*(CommandStatus.Errstr+sizeof(CommandStatus.Errstr)-1)='\0';
					printf("Remote errno: %d (%s)\n",(int)MODBUS_NTOHL((int)CommandStatus.Syserrno),CommandStatus.Errstr);
					return -1;
					break;
				default:
					printf("remote system returned a MODBUS exception for command MSXE321x__AcquisitionSequenceStopAndRelease\n");
					printf("reason: %s (%d)\n",modbus_exception_to_str(modbus->exception),modbus->exception);
					return -1;
					break;
			}
			break;
		case -3: // incorrect response from remote system
			printf("incorrect response from remote system\n");
			return -1;
			break;
		case -4: 
			printf("remote system returned a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed\n");
			return -1;
			break;
		default: 
			printf("unknown return code %d from MSXE321x__AcquisitionSequenceStopAndRelease()\n",ret);
			return -1;
			break;
	}
	printf("call to MSXE321x__AcquisitionSequenceStopAndRelease OK\n");
	return 0;
}

*/

int modbus_call_MSXE321x__AcquisitionSequenceStopAndRelease(struct modbus * modbus,
	uint32_t ulOption01
, struct GetLastCommandStatus_parameters_t * CommandStatus);

#endif //_MODBUS_MSXE321X_CLIENT_DEFINITION_H_


